Current Series Release Notes

4.13.0-34

New Features

  • Add support for key manager quota API

  • Added support for key manager secret ACL operations.

  • Added support list, get, update, delete, and create to share transfers from share file system service.

Upgrade Notes

  • A number of proxy APIs used parameters with _id suffixes despite accepting resources instances. These have now been renamed to drop this suffix. Backwards-compatible shims have been provided but these will be removed in the next major release.

  • Support for Python 3.10 has been dropped. The minimum version of Python now supported in 3.11.

  • The following accelerator proxy API methods have been renamed:

    • update_accelerator_request (to patch_accelerator_request)

    • update_deployable (to patch_deployable)

    Backwards-compatible shims are provided for all methods, but these are deprecated and will be removed in the next major release.

  • The folllowing metadata-related proxy methods have been renamed:

    Block Storage (v2)

    • get_snapshot_metadata (to fetch_snapshot_metadata)

    • get_volume_metadata (to fetch_volume_metadata)

    Block Storage (v3)

    • get_backup_metadata (to fetch_backup_metadata)

    • get_snapshot_metadata (to fetch_snapshot_metadata)

    • get_volume_metadata (to fetch_volume_metadata)

    Clustering (v1)

    • get_cluster_metadata (to fetch_cluster_metadata)

    Compute (v2)

    • set_image_metadata (to fetch_image_metadata)

    • set_server_metadata (to fetch_server_metadata)

    Placement (v1)

    • get_resource_provider_aggregates (to fetch_resource_provider_aggregates)

    Shared File System (v2)

    • get_share_metadata (to fetch_share_metadata)

    • get_share_metadata_item (to fetch_share_metadata_item)

    • create_share_metadata (to set_share_metadata)

    • update_share_metadata (to set_share_metadata)

    Backwards-compatible shims are provided for all methods, but these are deprecated and will be removed in the next major release.

    In addition, the set_aggregate_metadata compute API proxy method now expects metadata to be provided as keyword arguments. A backwards compatible shim is also provided for this.

Deprecation Notes

  • The ignore_missing option provided to all find_* proxy methods has been deprecated for removal. This option, and its default value of True, has been the source of many bugs and its use is almost always unintentional. Users are requested to explicitly pass False and to catch the openstack.exceptions.NotFoundException if the ignore missing behavior was indeed intentional.

4.13.0

New Features

  • Add vip_sg_ids attribute to the load balancer resource, which contains a list of security group IDs for the VIP port.

Deprecation Notes

  • The openstack.version module and associated objects has been deprecated for removal. Prefer use of importlib.metadata to inspect version information for installed packages.

4.12.0

New Features

  • Add update_password method to the identity proxy to support user self-service password reset.

  • Added ha_chassis_priority attribute to the network Agent resource. This field is populated by the Neutron l3-agent-scheduler-ha-priority API extension and indicates the OVN HA_Chassis failover priority for each gateway chassis hosting a router. The value is None for non-OVN mechanism drivers.

  • Added update_router_in_agent method to the network proxy and the Agent resource. This allows updating properties (such as ha_chassis_priority) of a router already associated with an L3 agent, using a PUT request on the l3-agent-scheduler API.

Bug Fixes

  • Fixed the ZoneImport resource base_path from /zones/tasks/import to /zones/tasks/imports to match the Designate API endpoint.

4.11.0

New Features

  • The 2.97 API microversion is now supported for the compute service. This adds a new API to manage shares, represented by the openstack.compute.v2.server_share.ShareMapping resource.

Deprecation Notes

  • Support for reporting metrics to InfluxDB has been deprecated for removal. The implementation relied on an EOL Python library and only supported InfluxDB v1.

Bug Fixes

  • Fixed port binding activation and deletion methods to correctly pass the host parameter as a path parameter instead of in the request body. The Neutron API expects the host in the URL path for these endpoints:

    • PUT /v2.0/ports/{port_id}/bindings/{host}/activate

    • DELETE /v2.0/ports/{port_id}/bindings/{host}

    Previously, the SDK was incorrectly sending the host parameter in both the URL path and the request body, which caused a TypeError in Neutron. The methods now correctly pass only the host identifier as a positional parameter, matching the Neutron API specification.

    For more information see bug 2146296

  • Session.connect_retry_delay is now configurable via clouds.yaml using the <service type>_connect_retry_delay and connect_retry_delay options.